﻿using data.DAO;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace data.Repository
{
    public interface IGroupRepository
    {
        /// <summary>
        /// Получение списка групп
        /// </summary>
        public IEnumerable<Group> GetAllGroups();
        
        /// <summary>
        /// Создание группы
        /// </summary>
        /// <param name="group">группа</param>
        public bool CreateGroup(Group group);

        /// <summary>
        /// Создание группы вместо со студентами
        /// </summary>
        /// <param name="group">группа</param>
        /// <param name="students">список студентов</param>
        public bool AddGroupWithStudents(Group group, IEnumerable<Student> students);

        /// <summary>
        /// TODO
        /// </summary>
        /// <param name="id"></param>
        /// <param name="students"></param>
        /// <returns></returns>
        public bool AddStudentsToGroup(int id, IEnumerable<Student> students);

        /// <summary>
        /// Удаление группы по индетефикатору
        /// </summary>
        /// <param name="id">индетефикатор</param>
        public bool DeleteGroup(int id);

        /// <summary>
        /// Обновление наименование группы
        /// </summary>
        /// <param name="id">индетефикатор</param>
        /// <param name="name">наименованвие</param>
        public bool UpdateGroup(int id, string name);
        
        /// <summary>
        /// Удаление всех студентов из группы
        /// </summary>
        /// <param name="id">индетефикатор</param>
        /// <returns></returns>
        public bool RemoveStudentsFromGroup(int id);

        /// <summary>
        /// Удаление студентов из группы по их индетефикатору
        /// </summary>
        /// <param name="id">индетефикатор группы</param>
        /// <param name="studentIds">список индетефикаторов студентов</param>
        /// <returns></returns>
        public bool RemoveStudentsFromGroupByIds(int id, IEnumerable<int> studentIds);

    }
}
