using domain.Entity;
using domain.Request;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace domain.UseCase
{
    public interface IGroupUseCase
    {
        public bool AddGroup(AddGroupRequest addGroupRequest);

        public void AddGroupWithStudents(AddGroupWithStudentRequest addGroupWithStudentRequest);

        public void AddStudentsToGroup(int id, IEnumerable<AddStudentRequest> students);

        public bool RemoveGroup(RemoveGroupRequest removeGroupRequest);

        public void EditGroup(EditGroupRequest editGroupRequest);

        public IEnumerable<GroupEntity> GetGroupsWithStudents();

        public GroupSubjectEntity GetGroupSubject(int id);

        public void RemoveStudentsFromGroup(int groupId);

        public void RemoveStudentsFromGroupByIds(int groupId, IEnumerable<int> studentIds);
    }
}
